import socket

def initSocketIteratePort(host, port):
    sock = None
    for prt in range(20):
        print 'port = ', prt+port
        print 'host = ', host
        for res in socket.getaddrinfo(host, prt+port, \
                                      socket.AF_UNSPEC, socket.SOCK_STREAM):
            af, socktype, proto, canonname, sa = res
            try:
                sock = socket.socket(af, socktype, proto)
                sock.settimeout(5)
            except socket.error, msg:
                sock = None
                continue
            try:
                sock.connect(sa)
                fd = sock.fileno()
            except socket.error, msg:
                sock.close()
                sock = None
                continue
            break
        if sock is None:
            print 'could not open socket on port: ', prt+port
        else:
            break
    return sock

def initSocketIteratePort2(host, port):
    sock = None
    for prt in range(20):
        print 'port = ', prt+port
        print 'host = ', host
        for res in socket.getaddrinfo(host, prt+port, \
                                      socket.AF_INET, socket.SOCK_STREAM):
            af, socktype, proto, canonname, sa = res
            try:
                sock = socket.socket(af, socktype, proto)
                sock.settimeout(5)
            except socket.error, msg:
                sock = None
                continue
            try:
                sock.connect(sa)
                fd = sock.fileno()
            except socket.error, msg:
                sock.close()
                sock = None
                continue
            break
        if sock is None:
            print 'could not open socket on port: ', prt+port
        else:
            break
    return sock

def initSocket(host, port):
    sock = None
    for res in socket.getaddrinfo(host, port, \
                                  socket.AF_UNSPEC, socket.SOCK_STREAM):
        af, socktype, proto, canonname, sa = res
        try:
            sock = socket.socket(af, socktype, proto)
            sock.settimeout(5)
        except socket.error, msg:
            sock = None
            continue
        try:
            sock.connect(sa)
            fd = sock.fileno()
        except socket.error, msg:
            sock.close()
            sock = None
            continue
        break
    if sock is None:
        print 'could not open socket on port: ', port
    return sock
