import numarray as na
import controlMountSocket

#luminos and zaber serial com info

nport = '192.168.3.137'
luminosPort = 4003
zaberPort =  4004

## luminosPort = '/dev/ttyr02'
## luminosBaud = 9600
luminosNAxis = 3
lum = controlMountSocket.mountControl(luminosPort, luminosNAxis)
## lum = controlMount.mountControl(luminosPort, luminosBaud, luminosNAxis)

## zaberPort = '/dev/ttyr03'
## zaberBaud = 9600
zaberNAxis = 1
zab = controlMountSocket.mountControl(zaberPort, zaberNAxis)
## zab = controlMount.mountControl(zaberPort, zaberBaud, zaberNAxis)

#IRCam
host  = '192.168.3.131'
port = 60000

coaddCount = -1

numberOfCumulatedImages = 1

##daq struct init pars
rows = 256
cols = 254
rowOffset = 0
colOffset = 1
nreads = 4
numberOfCoadds = 10
framesPerReset = 11
expTime = 0
numberOfFrames = 11
byteSwapping  =False
doReset = True
doDeinterlace = False
doImageSave = False
daqRunning = False
read = False
voffset = 4.0
vreset = 0.6
vd = 5.0
ictl = 3.3
continuousReadout = 1
savenum=0
numberCoherent=4

imageDirectory = '/data/'
imageFilename = 'fiberExplorer.fit'

## used by fiber explorer to save current fiber positions.
## used by IRCAM to read in when updating pyconfig....
luminos_currents = '/home/observe/mirc_python/.current_luminos_positions'
        
useBackground = False
numberOfBackgroundFrames = 1000
## end DAQ


dataArray = na.zeros((rows, cols), type=na.Float32)

